Index: trunk/kernel/arch/tsar/mmu-info.h
===================================================================
--- trunk/kernel/arch/tsar/mmu-info.h	(revision 1)
+++ trunk/kernel/arch/tsar/mmu-info.h	(revision 1)
@@ -0,0 +1,70 @@
+/*
+ * mmu-info.h - TSAR MMU registers & exceptions related informations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _MMU_INFO_H_
+#define _MMU_INFO_H_
+
+#ifndef _USE_MMU_INFO_H_
+#error This file must not be used directly
+#endif
+
+/* MMU Registers Interface */
+#define MMU_PTPR 	        0 	/* Page Table Pointer Register 	              R/W  */
+#define MMU_MODE 	        1 	/* Mode Register 	                      R/W  */
+#define MMU_ICACHE_FLUSH 	2 	/* Instruction Cache flush 	              W    */
+#define MMU_DCACHE_FLUSH 	3 	/* Data Cache flush 	                      W    */
+#define MMU_ITLB_INVAL 	        4 	/* Instruction TLB line invalidation 	      W    */
+#define MMU_DTLB_INVAL        	5 	/* Data TLB line Invalidation 	              W    */
+#define MMU_ICACHE_INVAL 	6 	/* Instruction Cache line invalidation 	      W    */
+#define MMU_DCACHE_INVAL 	7 	/* Data Cache line invalidation 	      W    */
+#define MMU_ICACHE_PREFETCH 	8 	/* Instruction Cache line prefetch 	      W    */
+#define MMU_DCACHE_PREFETCH 	9 	/* Data Cache line prefetch 	              W    */
+#define MMU_SYNC 	        10 	/* Complete pending writes 	              W    */
+#define MMU_IETR 	        11 	/* Instruction Exception Type Register 	      R    */
+#define MMU_DETR 	        12 	/* Data Exception Type Register 	      R    */
+#define MMU_IBVAR 	        13 	/* Instruction Bad Virtual Address Register   R    */
+#define MMU_DBVAR 	        14 	/* Data Bad Virtual Address Register 	      R    */
+#define MMU_PARAMS 	        15 	/* Caches & TLBs hardware parameters 	      R    */
+#define MMU_RELEASE 	        16 	/* Generic MMU release number 	              R    */
+#define MMU_WORD_LO 	        17 	/* Lowest part of a double word 	      R/W  */
+#define MMU_WORD_HI 	        18 	/* Highest part of a double word 	      R/W  */
+#define MMU_ICACHE_PA_INV 	19 	/* Instruction cache inval physical adressing W    */
+#define MMU_DCACHE_PA_INV 	20 	/* Data cache inval physical addressing       W    */
+#define MMU_DOUBLE_LL 	        21 	/* Double word linked load 	              W    */
+#define MMU_DOUBLE_SC 	        22 	/* Double word store conditional 	      W    */ 
+
+#include <types.h>
+
+/* MMU Exception Descriptor */
+struct mmu_except_info_s
+{
+	uint_t err;
+	char *name;
+	char *info;
+	char *severty;
+};
+
+typedef struct mmu_except_info_s mmu_except_info_t;
+
+inline mmu_except_info_t* mmu_except_get_entry(uint_t mmu_err_val);
+
+#endif	/* _MMU_INFO_H_ */
Index: trunk/kernel/arch/tsar/rt_timer.c
===================================================================
--- trunk/kernel/arch/tsar/rt_timer.c	(revision 1)
+++ trunk/kernel/arch/tsar/rt_timer.c	(revision 1)
@@ -0,0 +1,61 @@
+/*
+ * rt_timer.c - real-time timer related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <errno.h>
+#include <rt_timer.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+
+struct device_s rt_timer;
+
+/** Initialize Real-Time timer source */
+error_t rt_timer_init(uint_t period, uint_t withIrq)
+{
+	return 0;
+}
+
+/** Read Real-Time timer current value  */
+error_t rt_timer_read(uint_t *time)
+{
+	*time = cpu_time_stamp();
+	return 0;
+}
+
+/** Set Real-Time timer's current value */
+error_t rt_timer_set(uint_t time)
+{
+	return ENOSYS;
+}
+
+/** Set Real-Time timer's period */
+error_t rt_timer_setperiod(uint_t period)
+{
+	return ENOSYS;
+}
+
+/** Send commands to Real-Time timer device */
+error_t rt_timer_ctrl(struct rt_params_s *param)
+{
+	return ENOSYS;
+}
Index: trunk/kernel/devices/:w
===================================================================
--- trunk/kernel/devices/:w	(revision 1)
+++ trunk/kernel/devices/:w	(revision 1)
@@ -0,0 +1,109 @@
+/*
+ * dev_iox.h - IOX (bridge to external I/O) generic device API.
+ *
+ * Authors   Alain Greiner  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTIOXLAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DEV_IOX_H_
+#define _DEV_IOX_H_
+
+#include <almos_config.h>
+#include <hal_types.h>
+#include <spinlock.h>
+
+/*****************************************************************************************
+ *     Generic IOX (bridge to external IO peripherals) definition.
+ *
+ * The IOX device is used to access external peripherals. It implements an IO-MMU service 
+ * for DMA transactions launched by DMA capable external peripherals.
+ * This IOX peripheral is acting as a dynamically configurable bridge, used for others 
+ * I/O operations. Therefore, ALMOS-MKH does not use the IOX device waiting queue,
+ * and calls directly the IOX driver blocking functions, using the device lock to 
+ * get exclusive access to the IOX bridge internal state.
+ ****************************************************************************************/
+ 
+
+/*****************************************************************************************
+ * This enum defines the various implementations of the IOX generic device.
+ * This array must be kept consistent with the define in arch_info.h file
+ ****************************************************************************************/
+
+enum iox_impl_e
+{
+    IMPL_IOX_IOB =   0,         /* vci_iob component used in TSAR                       */
+    IMPL_IOX_I86 =   1,         /* TBD                                                  */
+}
+iox_impl_t;
+
+/*****************************************************************************************
+ * This function initializes the IOX device descriptor with IOMMU disabled.
+ *****************************************************************************************
+ * @ dev_xp     : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_init( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function activates the IOMMU for the IOX device identified by its
+ * extended pointer.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_iommu_enable( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function desactivates the IO-MMU for the IOX device identified by its
+ * extended pointer.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ ****************************************************************************************/
+void dev_iox_iommu_disable( xptr_t dev_xp );
+
+/*****************************************************************************************
+ * This function set a new value in the IO-MMU PTPR register.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ wdata    : value to be written in PTPR register.
+ ****************************************************************************************/
+void dev_iox_set_ptpr( xptr_t    dev_xp,
+                       uint32_t  wdata );
+                        
+/*****************************************************************************************
+ * This function invalidates an IOMMU TLB entry identified by its vpn.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ vpn      : virtual page number in IO virtual space.
+ ****************************************************************************************/
+void dev_iox_inval_page( xptr_t  dev_xp,
+                         vpn_t   vpn );
+
+/*****************************************************************************************
+ * This function return informations relative to an error reported by the IOMMU.
+ *****************************************************************************************
+ * @ dev_xp   : extended pointer on IOX device descriptor.
+ * @ error    : [out] pointer on buffer for erro type.
+ * @ bvar     : [out] pointer on buffer for bad virtual address.
+ * @ srcid    : [out] pointer on buffer for faulty peripheral index.
+ ****************************************************************************************/
+void dev_iox_get_status( xptr_t     dev_xp,
+                         uint32_t * error,
+                         uint32_t * bvar,
+                         uint32_t * srcid );
+
+#endif  /* _DEV_IOX_H_ */
Index: trunk/kernel/devices/dev_icu.c
===================================================================
--- trunk/kernel/devices/dev_icu.c	(revision 1)
+++ trunk/kernel/devices/dev_icu.c	(revision 1)
@@ -0,0 +1,492 @@
+/*
+ * dev_icu.c - ICU (Interrupt Controler Unit) generic device API implementation.
+ *
+ * Authors   Alain Greiner  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_types.h>
+#include <hal_special.h>
+#include <device.h>
+#include <thread.h>
+#include <cluster.h>
+#include <printk.h>
+#include <memcpy.h>
+#include <spinlock.h>
+#include <soclib_xcu.h>
+#include <dev_icu.h>
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// Extern global variables
+/////////////////////////////////////////////////////////////////////////////////////////
+
+extern devices_directory_t  devices_dir;         // allocated in kernel_init.c
+
+extern devices_input_irq_t  devices_input_irq;   // allocated in kernel_init.c
+
+
+///////////////////////////////////
+void dev_icu_init( xptr_t   dev_xp,
+                   uint32_t hwi_nr,
+                   uint32_t wti_nr,
+                   uint32_t pti_nr )
+{
+    // get ICU device cluster and local pointer
+    cxy_t      dev_cxy = GET_CXY( dev_xp );
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    if( dev_cxy != local_cxy )
+    {
+        printk("\n[PANIC] %s for cluster %x must be local\n",
+               __FUNCTION__ , local_cxy );
+        hal_core_sleep();
+    }
+
+    // set ICU device extension fields
+    dev_ptr->ext.icu.hwi_nr     = hwi_nr;
+    dev_ptr->ext.icu.wti_nr     = wti_nr;
+    dev_ptr->ext.icu.pti_nr     = pti_nr;
+    dev_ptr->ext.icu.wti_bitmap = 0;
+    spinlock_init( &dev_ptr->ext.icu.wti_lock );
+   
+    // get implementation index from ICU device descriptor
+    uint32_t impl = dev_ptr->impl;
+
+    // set field "name" in device descriptor
+    // and call the relevant driver init function
+    if( impl == IMPL_ICU_XCU )
+    {
+        memcpy( dev_ptr->name , "ICU_XCU" , 16 );
+
+        uint32_t     lid;
+        cluster_t  * cluster = LOCAL_CLUSTER;
+        for( lid = 0 ; lid < cluster->cores_nr ; lid++ )
+        {
+            soclib_xcu_init( dev_ptr , lid );
+        }
+    }
+    else
+    {
+        printk("\n[PANIC] %s : undefined ICU implementation for cluste %x\n",
+               __FUNCTION__ , local_cxy );
+        hal_core_sleep();
+    }
+} // end dev_icu_init()
+
+/////////////////////////////////////////////////////////////////////////////////////
+// This static function check the irq_type / irq_index arguments for a remote ICU.
+// It is called by the dev_icu_enable_irq() & dev_icu_disable_irq() functions.
+// returns 0 if OK / returns non zero if invalid arguments
+/////////////////////////////////////////////////////////////////////////////////////
+static inline void dev_icu_check_irq( xptr_t     icu_xp,
+                                      uint32_t   irq_type,
+                                      uint32_t   irq_index )
+{
+    // get cluster and local pointer on remote ICU
+    cxy_t      icu_cxy = GET_CXY( icu_xp );
+    device_t * icu_ptr = (device_t *)GET_PTR( icu_xp );
+
+    if( irq_type == HWI_TYPE ) 
+    {
+        if( irq_index >= hal_remote_lw( XPTR( icu_cxy , &icu_ptr->ext.icu.hwi_nr ) ) )
+        {
+            printk("\n[PANIC] in %s : illegal HWI index = %d for ICU in cluster %x\n",
+                   __FUNCTION__ , irq_index , icu_cxy );
+            hal_core_sleep();
+        }
+    }
+    if( irq_type == WTI_TYPE )
+    {
+        if( irq_index >= hal_remote_lw( XPTR( icu_cxy , &icu_ptr->ext.icu.wti_nr ) ) )
+        {
+            printk("\n[PANIC] in %s : illegal WTI index = %d for ICU in cluster %x\n",
+                   __FUNCTION__ , irq_index , icu_cxy );
+            hal_core_sleep();
+        }
+    }
+    if( irq_type == PTI_TYPE )
+    {
+        if( irq_index >= hal_remote_lw( XPTR( icu_cxy , &icu_ptr->ext.icu.pti_nr ) ) )
+        {
+            printk("\n[PANIC] in %s : illegal PTI index = %d for ICU in cluster %x\n",
+                   __FUNCTION__ , irq_index , icu_cxy );
+            hal_core_sleep();
+        }
+    }
+}  // end dev_icu check irq()
+
+////////////////////////////////////////////
+void dev_icu_enable_irq( cxy_t      icu_cxy,
+                         lid_t      lid,
+                         uint32_t   irq_type,
+                         uint32_t   irq_index,
+                         xptr_t     src_dev_xp )
+{
+    // get extended pointer & local pointer on remote ICU device
+    xptr_t     icu_xp  = devices_dir.icu[icu_cxy];
+    device_t * icu_ptr = (device_t *)GET_PTR( icu_xp );
+
+    // check IRQ type and index
+    dev_icu_check_irq( icu_xp , irq_type , irq_index );
+
+    // (1) call implementation specific ICU driver to enable IRQ
+    if( icu_ptr->impl == IMPL_ICU_XCU ) 
+    {
+        soclib_xcu_enable_irq( icu_xp , 1<<irq_index , irq_type , lid );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // (2) get selected remote core local pointer, and register
+    // source device xptr in relevant interrupt vector
+
+    core_t * core_ptr = hal_remote_lpt( XPTR( icu_cxy , &LOCAL_CLUSTER->core_tbl[lid] ) );
+    xptr_t   core_xp  = XPTR( icu_cxy , core_ptr );
+	core_set_irq_vector_entry( core_xp , irq_type , irq_index , src_dev_xp );
+
+    // (3) get extended pointer on source device, and 
+    // register IRQ type and index in source device descriptor
+
+    cxy_t      src_dev_cxy = GET_CXY( src_dev_xp );
+    device_t * src_dev_ptr = (device_t *)GET_PTR( src_dev_xp );
+
+    hal_remote_sw( XPTR( src_dev_cxy , &src_dev_ptr->irq_type ) , irq_type );
+    hal_remote_sw( XPTR( src_dev_cxy , &src_dev_ptr->irq_id   ) , irq_index );
+
+}  // end dev_icu_enable_irq()
+
+/////////////////////////////////////////////
+void dev_icu_disable_irq( cxy_t      icu_cxy,
+                          lid_t      lid,
+                          uint32_t   irq_type,
+                          uint32_t   irq_index )
+{
+    // get extended pointer & local pointer on remote ICU device
+    xptr_t  icu_xp = devices_dir.icu[icu_cxy];
+    device_t * icu_ptr = (device_t *)GET_PTR( icu_xp );
+
+    // check IRQ type and index
+    dev_icu_check_irq( icu_xp , irq_type , irq_index );
+
+    // (1) call the implementation specific ICU driver to disable IRQ 
+    if( icu_ptr->impl == IMPL_ICU_XCU ) 
+    {
+        soclib_xcu_disable_irq( icu_xp , 1<<irq_index , irq_type , lid );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // (2) get selected remote core local pointer, and remove
+    // the source device xptr from relevant interrupt vector
+
+    core_t * core_ptr = hal_remote_lpt( XPTR( icu_cxy , &LOCAL_CLUSTER->core_tbl[lid] ) );
+    xptr_t   core_xp  = XPTR( icu_cxy , core_ptr );
+	core_set_irq_vector_entry( core_xp , irq_type , irq_index , XPTR_NULL );
+
+} // end dev_icu_disable_irq()
+
+//////////////////////////////////////////////
+void dev_icu_set_period( uint32_t   pti_index,
+                         uint32_t   period )
+{
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // check PTI index
+    if( pti_index >= icu->ext.icu.pti_nr ) 
+    {
+        printk("\n[PANIC] in %s : illegal PTI index = %d\n", __FUNCTION__ , pti_index );
+        hal_core_sleep();
+    }
+
+    // call the implementation specific driver ICU to set period 
+    if( icu->impl == IMPL_ICU_XCU ) 
+    {
+        soclib_xcu_set_period( icu , pti_index , period );
+    }
+}  // end dev_icu_set_period()
+
+////////////////////////////////////////////
+void dev_icu_ack_timer( uint32_t pti_index )
+{
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // check PTI index
+    if( pti_index >= icu->ext.icu.pti_nr ) 
+    {
+        printk("\n[PANIC] in %s : illegal PTI index = %d\n", __FUNCTION__ , pti_index );
+        hal_core_sleep();
+    }
+
+    // call the implementation specific driver ICU to acknowledge PTI IRQ
+    if( icu->impl == IMPL_ICU_XCU ) 
+    {
+        soclib_xcu_ack_timer( icu , pti_index );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+}  // end dev_icu_ack_timer()
+
+////////////////////////////////////
+void dev_icu_send_ipi( cxy_t    cxy,
+                       lid_t    lid )
+{
+    // check arguments 
+    cluster_t * cluster  = LOCAL_CLUSTER;
+    uint32_t    y_width  = cluster->y_width;
+    uint32_t    x_size   = cluster->x_size;
+    uint32_t    y_size   = cluster->y_size;
+    uint32_t    cores_nr = cluster->cores_nr;
+    uint32_t    x = cxy >> y_width;
+    uint32_t    y = cxy & ((1<<y_width)-1);
+
+    if( (x >= x_size) || (y >= y_size) )
+    {
+        hal_core_sleep("%s : illegal cluster identifier = %x\n", __FUNCTION__ , cxy );
+    } 
+    if( lid >= cores_nr )
+    {
+        hal_core_sleep("%s : illegal core local index = %d\n", __FUNCTION__ , lid );
+    } 
+
+    // get extended pointer on target ICU device
+    xptr_t icu_xp = devices_dir.icu[cxy];
+
+     // get target ICU cluster and local pointer
+    cxy_t      cxy_icu = GET_CXY( icu_xp );
+    device_t * ptr_icu = (device_t *)GET_PTR( icu_xp );
+
+    // get driver implementation from target ICU device
+    uint32_t impl = hal_remote_lw( XPTR( cxy_icu , &ptr_icu->impl ) );   
+
+    // call the implementation specific ICU driver to send IPI
+    if( impl == IMPL_ICU_XCU ) 
+    {
+        soclib_xcu_send_ipi( icu_xp , lid );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+}  // end dev_icu_send_ipi()
+
+//////////////////////////
+void dev_icu_irq_handler()
+{
+    uint32_t   hwi_status;   // HWI index + 1  / no pending HWI if 0
+    uint32_t   wti_status;   // WTI index + 1  / no pending WTI if 0
+    uint32_t   pti_status;   // PTI index + 1  / no pending PTI if 0
+    xptr_t     src_dev_xp;   // extended pointer on source device descriptor
+    cxy_t      src_dev_cxy;  // source device cluster
+    device_t * src_dev_ptr;  // source device local pointer
+    uint32_t   index;        // IRQ index
+
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // call the implementation specific ICU driver  
+    // to return highest priority pending IRQ of each type
+    if( icu->impl == IMPL_ICU_XCU )
+    {
+        soclib_xcu_get_status( icu , core->lid , &hwi_status , &wti_status , &pti_status );
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // analyse ICU status and handle up to 3 pending IRQ (one WTI, one HWI, one PTI)
+
+    if( wti_status )          // pending WTI TODO what about IPIs ???  [AG]
+	{
+        index = wti_status - 1;
+
+        // get extended pointer on IRQ source device
+		src_dev_xp  = core->wti_vector[index];
+        src_dev_cxy = GET_CXY( src_dev_xp );
+        src_dev_ptr = (device_t *)GET_PTR( src_dev_xp );
+
+		if( src_dev_xp == XPTR_NULL )        // strange, but not fatal => disable IRQ
+		{
+            printk("\n[WARNING] in %s : no handler for WTI %d on core %d in cluster %x\n",
+                   __FUNCTION__ , index , core->lid , local_cxy );
+	        core->spurious_irqs ++;
+            dev_icu_disable_irq( local_cxy , core->lid , WTI_TYPE , index ); 
+		}
+        else if( src_dev_cxy != local_cxy )  // WTI must be handled in device cluster
+        {
+            printk("\n[PANIC] in %s : non local WTI %d on core %d in cluster %x\n",
+                   __FUNCTION__ , index , core->lid , local_cxy );
+            hal_core_sleep();
+        }
+        else                                 // call relevant ISR
+        {
+		    icu_dmsg("\n[INFO] %s received WTI : index = %d for cpu %d in cluster %d\n",
+                     __FUNCTION__ , index , core->lid , local_cxy );
+
+	        src_dev_ptr->isr( src_dev_ptr );
+        }
+	}
+
+	if( hwi_status )      // pending HWI
+	{
+        index = hwi_status - 1;
+
+        // get pointer on IRQ source device
+		src_dev_xp  = core->wti_vector[index];
+        src_dev_cxy = GET_CXY( src_dev_xp );
+        src_dev_ptr = (device_t *)GET_PTR( src_dev_xp );
+
+		if( src_dev_xp == XPTR_NULL )        // strange, but not fatal => disable IRQ
+		{
+            printk("\n[WARNING] in %s : no handler for HWI %d on core %d in cluster %x\n",
+                   __FUNCTION__ , index , core->lid , local_cxy );
+	        core->spurious_irqs ++;
+            dev_icu_disable_irq( local_cxy , core->lid , HWI_TYPE , index ); 
+		}
+        else if( src_dev_cxy != local_cxy )  // HWI must be handled in device cluster
+        {
+            printk("\n[PANIC] in %s : non local HWI %d on core %d in cluster %x\n",
+                   __FUNCTION__ , index , core->lid , local_cxy );
+            hal_core_sleep();
+        }
+        else                    // call relevant ISR
+        {
+		    icu_dmsg("\n[INFO] %s received HWI : index = %d for cpu %d in cluster %d\n",
+                     __FUNCTION__ , index , core->lid , local_cxy );
+
+		    src_dev_ptr->isr( src_dev_ptr );
+        }
+	}
+
+    if( pti_status )      // pending PTI
+	{
+        index = pti_status - 1;
+
+		icu_dmsg("\n[INFO] %s received PTI : index = %d for cpu %d in cluster %d\n",
+                 __FUNCTION__ , index , core->lid , local_cxy );
+
+        // acknowledge PTI
+        dev_icu_ack_timer( index );
+
+        // execute all actions related to TICK event
+        core_clock( core );
+	}
+}  // end dev_icu_irq_handler()
+
+////////////////////////////
+uint32_t dev_icu_wti_alloc()
+{
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // get bitmap pointer, lock, and size
+    bitmap_t   * bitmap = &icu->ext.icu.wti_bitmap;
+    spinlock_t * lock   = &icu->ext.icu.wti_lock;
+    uint32_t     size   =  icu->ext.icu.wti_nr;
+
+    // get lock protecting WTI allocator
+    spinlock_lock( lock );
+
+    // get first free mailbox index
+    uint32_t index = (uint32_t)bitmap_ffc( bitmap , size );
+  
+    // set bitmap entry if found
+    if( index < size ) bitmap_set( bitmap , index );
+
+    // release lock
+    spinlock_unlock( lock );
+
+    return index;
+}  // end dev_icu_wti_alloc()
+
+//////////////////////////////////////////
+void dev_icu_wti_release( uint32_t index )
+{
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // get bitmap pointer, lock, and size
+    bitmap_t   * bitmap = &icu->ext.icu.wti_bitmap;
+    spinlock_t * lock   = &icu->ext.icu.wti_lock;
+    uint32_t     size   =  icu->ext.icu.wti_nr;
+
+    // check index
+    if( index >= size )
+    {
+        printk("\n[PANIC] in %s : illegal WTI index = %d on core %d in cluster %x\n",
+               __FUNCTION__ , index , core->lid , local_cxy );
+        hal_core_sleep();
+    }
+
+    // get lock protecting WTI allocator
+    spinlock_lock( lock );
+
+    // clear bitmap entry 
+    bitmap_clear( bitmap , index );
+
+    // release lock
+    spinlock_unlock( lock );
+}  // end dev_icu_wti_release()
+
+///////////////////////////////////////
+xptr_t dev_icu_wti_xptr( cxy_t     cxy,
+                         uint32_t  wti_id )
+{
+    uint32_t * ptr = NULL;    // local pointer on mailbox
+    
+    // get pointer on local ICU device descriptor
+    core_t   * core = CURRENT_CORE;
+    device_t * icu  = core->icu;
+
+    // call implementation specific ICU driver
+    if( icu->impl == IMPL_ICU_XCU )
+    {
+        ptr = soclib_xcu_wti_ptr( icu , wti_id );   
+    }
+    else
+    {
+        printk("\n[PANIC] in %s : undefined ICU implementation" , __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // return extended pointer on mailbox
+    return XPTR( cxy , ptr );
+
+}   // end dev_icu_wti_xptr()
+
+
